import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:veriff_flutter/src/branding.dart';

void main() {
  Branding? branding;

  tearDown(() {
    branding = null;
  });

  test("Test Branding is created with only themeColor", () async {
    String testThemeColor = "test-color";
    branding = Branding(themeColor: testThemeColor);
    expect(branding?.themeColor, testThemeColor);
    expect(branding?.backgroundColor, null);
    expect(branding?.statusBarColor, null);
    expect(branding?.primaryTextColor, null);
    expect(branding?.secondaryTextColor, null);
    expect(branding?.buttonCornerRadius, null);
    expect(branding?.logo, null);
    expect(branding?.androidNotificationIcon, null);
  });

  test("Test Branding is created with only buttonCornerRadius", () async {
    int testButtonCornerRadius = 5;
    branding = Branding(buttonCornerRadius: testButtonCornerRadius);
    expect(branding?.buttonCornerRadius, testButtonCornerRadius);
    expect(branding?.backgroundColor, null);
    expect(branding?.statusBarColor, null);
    expect(branding?.primaryTextColor, null);
    expect(branding?.secondaryTextColor, null);
    expect(branding?.themeColor, null);
    expect(branding?.logo, null);
    expect(branding?.androidNotificationIcon, null);
  });

  test("Test Branding as map created correctly.", () async {
    int testButtonCornerRadius = 5;
    branding = Branding(buttonCornerRadius: testButtonCornerRadius);
    Map? brandingAsMap = branding?.asMap();
    expect(brandingAsMap?['themeColor'], null);
    expect(brandingAsMap?['backgroundColor'], null);
    expect(brandingAsMap?['statusBarColor'], null);
    expect(brandingAsMap?['primaryTextColor'], null);
    expect(brandingAsMap?['secondaryTextColor'], null);
    expect(brandingAsMap?['buttonCornerRadius'], testButtonCornerRadius);
    expect(brandingAsMap?['logo'], null);
    expect(brandingAsMap?['androidNotificationIcon'], null);
  });

  test("Test Branding as map created correctly with AssetImage.", () async {
    AssetImage? testAssetImage = AssetImage("test-image");
    branding = Branding(logo: testAssetImage);
    Map? brandingAsMap = branding?.asMap();
    expect(brandingAsMap?['logo'], "test-image");
  });
}
